<script type="text/x-red" data-template-name="socketio-config">
	<div class="form-row">
		<input type="checkbox" id="node-config-input-useNodePort" style="display: inline-block; width: auto; vertical-align: top;">
		<label for="node-config-input-useNodePort" style="width: auto; margin-left: 10px;"> Listen to Node-RED port</label>
		<div id="select-custom-port" class="hide">
			<label for="node-config-input-port"><i class="fa fa-terminal"></i> Port</label>
			<input type="text" id="node-config-input-port">
		</div>
	</div>
	<div class="form-row">
		<label for="node-config-input-path"><i class="fa fa-paper-plane-o"></i> Path</label>
		<input type="text" id="node-config-input-path" placeholder="/socket">
	</div>
	<div class="form-row">
		<label for="node-input-server"><i class="fa fa-cog"></i> Options</label>
		<ol id="node-input-options-socket"></ol>
	</div>
</script>

<script type="text/x-red" data-help-name="socketio-config">
  <b>Config</b>:<br/>
  <ul>
      <li><b>Listen to Node-RED port (checked)</b> Allow use the same port of <b>Node-RED</b> to listen socket connections.</li>
      <li><b>Listen to Node-RED port (unchecked)</b> Allow select other port to listen socket connections. </br> Use input <b>Port</b> to define port for use.</li>
  </ul>
  <b>Options</b>:<br/>
  <ul>
      <li><b>Param</b> Define option key for example <b>cors</b></li>
			<li><b>Value</b> Define value for key for example <b>{"origin":"*"}</b></li>
			<li><b>Json</b> Define if value is <b>Object</b> or <b>String</b> check for object and uncheck for string</li>
  </ul>
	<b>Available options are in</b>:<br/>
	<a href="https://socket.io/docs/v4/server-options/#">Socket.IO options</a>
</script>

<script type="text/javascript">
	RED.nodes.registerType('socketio-config', {
		category: 'config',
		defaults: {
			useNodePort: { value: true },
			path: { value: "/socket" },
			port: { value: 1881, required: true, validate: RED.validators.number() },
			options: { value: [{ "cors": "*", "type": true, "index": 0 }] }
		},
		label: function () {
			return this.useNodePort ? "Socket.IO at Node-RED port" : `Socket.IO listen on port: ${this.port}`;
		},
		oneditprepare: function () {
			$("#node-config-input-useNodePort").change((e) => {
				if (e.target.checked) {
					$("#select-custom-port").hide();
				}
				else {
					$("#select-custom-port").show();
				}
			});

			if (this.useNodePort) {
				$("#node-config-input-useNodePort").prop('checked', true);
			} else {
				$("#node-config-input-useNodePort").prop('checked', false);
			}
			$("#node-config-input-useNodePort").change();

			$("#node-input-options-socket").css('min-height', '250px').css('min-width', '450px').editableList({
				sortable: true,
				removable: true,
				addItem: function (row, index, data) {
					const keyName = Object.keys(data)[0];
					let div = $('<div/>', { style: "display: inline-block; width: auto; vertical-align: top;" }).appendTo(row);
					$('<label/>', { for: "node-input-options-key-" + index, style: "margin-left: 3px; width: 40px;" }).text("Param: ").appendTo(div);
					$('<input/>', { id: "node-input-options-key-" + index, type: "text", style: "margin-left: 10px; width: 80px;" }).val(keyName).appendTo(div);
					$('<label/>', { for: "node-input-options-value-" + index, style: "margin-left: 10px; width: 40px;" }).text("Value: ").appendTo(div);
					$('<input/>', { id: "node-input-options-value-" + index, type: "text", style: "margin-left: 3px; width: 130px;" }).val(typeof data[keyName] == "object" ? JSON.stringify(data[keyName]) : data[keyName]).appendTo(div);
					$('<label/>', { for: "node-input-options-type-" + index, style: "margin-left: 10px; width: 20px;" }).text("json").appendTo(div);
					$('<input/>', { id: "node-input-options-type-" + index, type: "checkbox", style: "margin-left: 10px; width: 20px" }).prop("checked", data.type).appendTo(div);
				}
			});

			$("#node-input-options-socket").editableList("addItems", this.options);
		},
		oneditsave: function () {
			this.options = [];
			const options = $("#node-input-options-socket").editableList("items");
			options.each((i) => {
				const newOption = {
					[options[i][0].children[0].children[1].value]: options[i][0].children[0].children[5].checked ? JSON.parse(options[i][0].children[0].children[3].value) : options[i][0].children[0].children[3].value,
					index: i,
					type: options[i][0].children[0].children[5].checked
				}
				this.options[i] = newOption;
			})
		}
	});
</script>

<script type="text/x-red" data-template-name="socketio-server">
	<div class="form-row">
		<label for="node-input-name"><i class="fa fa-tag"></i> Name</label>
		<input type="text" id="node-input-name" placeholder="Name">
	</div>
	<div class="form-row">
		<label for="node-input-server"><i class="fa fa-server"></i> Server</label>
		<input type="text" id="node-input-server">
	</div>
</script>

<script type="text/x-red" data-help-name="socketio-server">
	<b>Socket.IO node</b>:<br/>
  <ul>
      <li><b>Listen to Node-RED port (checked)</b> Allow use the same port of <b>Node-RED</b> to listen socket connections.</li>
      <li><b>Listen to Node-RED port (unchecked)</b> Allow select other port to listen socket connections. </br> Use input <b>Port</b> to define port for use.</li>
  </ul>
	<p>Socket IO Input node</p>
	<p>Implementation of a SocketIO server</p>
	<p>This node can be used to receive socket events from a web page</p>
	<br />
	<p>This node output:</p>
	<p><code>msg.payload</code> as <i>Object</i> = event data received</p>
	<p><code>msg.socketIOEvent</code> as <i>String</i> = event type received</p>
	<p><code>msg.socketIOId</code> as <i>String</i> = socket id that generated the event</p>
	<p><code>msg.socketIOStaticProperties</code> as <i>Object</i> = User defined properties added to the socket</p>
	<br />
	<p>The user can add all the topic/event he want</p>
	<p>The predefined <code>connect/disconnect</code> etc... events are automatically implemented</p>
</script>

<script type="text/javascript">
	RED.nodes.registerType('socketio-server', {
		category: "Socket.IO",
		color: "#25c2a0",
		defaults: {
			name: { value: "" },
			server: { value: "", required: true, type: "socketio-config" }
		},
		inputs: 1,
		outputs: 1,
		icon: "bridge.png",
		inputLabels: "Emit",
		outputLabels: "Receive",
		label: function () {
			return this.name || "Socket.IO server";
		},
		oneditprepare: function () {
		},
		oneditsave: function () {
		}
	});
</script>